<?php	session_start(); ?>

<html>
<body>

<table class="top_menu" border="0" id="tabQueryResults">
<tr class="top_menu">
	<td class="top_menu_heading" colspan="4"><h2>Pulse Profiles</h2></td>
</tr>

<tr class="top_menu">
	<td class="top_menu"  align="left" width="20%"><a class="top_menu" href="index.php?command=logout">Logout</a> | 
<a class="top_menu" href="index.php?actions=new_query">New query</a></td>

<td class="top_menu" align="right" width="1%"><a href="<?php echo $PHP_SELF;?>?state=results">
<img alt="Revert to query results" border="0" title="Revert to query results" src="images/table_30px_white.png"></img></a>
</td>
</tr>
</table>
<?php
	include_once("constants.php");
	include_once("utils.php");
	
	////////////////////////
	// Initialise parameters
	//
	
	// Array of observations that the user has selected to view their profiles
	$obs = get_param('selected_obs', $HTTP_GET_VARS);
	
	// Array of associative arrays containing the queried results
	$all_results = get_param('results', $HTTP_GET_VARS);
	
	// Array containing the full paths of all the FTp scrunched profiles to view
	$profile_locations = array();
	
	//echo "Number of all_results = " . count($all_results) . "<br>\n";

	
	// Collect the form values
	//$file      = $HTTP_GET_VARS['file'];
	//$profile_dir       = rtrim($HTTP_GET_VARS['dir'], "/");
	//$plot_type = $HTTP_GET_VARS['plot'];
	/*
	putenv("PSRHOME=".PSRHOME);
	putenv("PGPLOT_FONT=".PGPLOT_FONT);
	
	putenv("LD_LIBRARY_PATH=".LD_LIBRARY_PATH.":$ldlibpath");
	$ldlibpath = getenv("LD_LIBRARY_PATH");
	
	putenv("PGPLOT_DIR=".PGPLOT_DIR);
	$pgplot_dir = getenv("PGPLOT_DIR");
	
	putenv("PATH=".PATH);
	
	echo "libpath = $ldlibpath, pgplot_dir = $pgplot_dir<br>\n";
	*/

	$count = 0;
	
	// If the user wants to view cals
	if ($_SESSION['display_cals']) {
		//echo "Want to display cals<br>\n";
		$display_cals = true;
	}
	else {
		//echo "Don't want to display cals<br>\n";
		$display_cals = false;
	}
	
	$obs_to_plot = array();
	
	displayProfiles($all_results, $obs, $display_cals);



function displayProfiles($all_archives, $selected_archives_indices, $display_cals) {

	$num_cols = NUM_PROFILE_COLUMNS;
	
	$num_rows = NUM_PROFILE_ROWS;
	
	$obs_cals;
	
	//print_r($selected_archives_indices);
	
	$archives_to_plot = count($selected_archives_indices);
		
	// If there are fewer profiles to plot than columns, 
	// plot these profiles on a full plot
	if ( count($archives_to_plot) < $num_cols) {
		$num_cols = $num_obs;
		$num_rows = 1;
	}
		
	if ($display_cals) {	
		$obs_cals = $_SESSION['obs_cals'];
// 		echo "obs_cals = <pre>";
// 		print_r($obs_cals);
// 		echo "</pre>";
		$num_cols = 1;
		$num_rows = 1;
	} 
	
	// An array of profiles to display in a pgplot instance
	$display_plots = array();
	
	for ($i = 0; $i < count($selected_archives_indices); $i++) {
		//echo "index = $selected_archives_indices[$i]<br>\n";
		
		// Need to append the suffix so the location points to the scrunched data
		$profile_dir = rtrim($all_archives[$selected_archives_indices[$i]][DATA_LOCATION], "/") . SCRUNCHED_DIR_EXT;
		
		echo "profile_dir is " . $profile_dir . "<br>\n";
		
		//array_push($profile_locations, $profile_location);
		
		$file = $all_archives[$selected_archives_indices[$i]][FILENAME];
		
		echo "file = $file <br>\n";

		if ($display_cals) {
			//echo "obs_cal[$selected_archives_indices[$i]] = <pre>";
			//print_r($obs_cals[$selected_archives_indices[$i]]);
			//echo "</pre>\n";
			$calfile = $obs_cals[$selected_archives_indices[$i]][FILENAME];
			//echo "Filename = $file, calfilename = $calfile<br>\n";
		}
		
		list($file_no_extension, $extension) =  split("\.", $file);
		
		echo "File prefix = $file_no_extension, suffix = $extension<br>\n";
		
		$dirs = split("/", $profile_dir);

		$pulsar_name = $dirs[count($dirs)-1];
		echo "Pulsar name = $pulsar_name<br>\n";

		exec("mkdir -p ".WORKING_DIR."/$pulsar_name");
		exec("mkdir -p ".PLOT_DIR."/$pulsar_name");
		
		// Need to create a symlink first because may not have write
		// access to the data directory. Don't want to mess up the data dir anyway
		if (!file_exists(WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT)) {
		
			echo WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT." doesn't exist<br>\n";
			if (file_exists("$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT)) {
			
				echo "$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT." exists<br>\n";
				
				// Create a symlink in the working directory (which will be cleaned up regularly using a cron job)
				if (symlink ("$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT, 
					     WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT)) {
				
					echo "Successfully created symlink: $profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT. " => " . WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT."<br>\n";
				}
				else {
					echo "Failed to create symlink<br>\n";
				}
			}
			else {
				echo "$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT." does NOT exist<br>\n";
			}
		}
		else {
			echo WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT." exists<br>\n";
		}
		
		array_push($display_plots, "$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT);
		
		print_r($display_plots); echo "<br>\n";
		
		$output_filename = "$pulsar_name/$file_no_extension.".IMAGE_EXT;//date("YmdHis") . "." . IMAGE_EXT;
		echo "output_filename = $output_filename<br>\n";

		//echo count($display_plots) . " " . $num_cols*$num_rows . ", i = " . $i . " ==? " . (count($archives_to_plot)-1) . "<br>\n";
		
		if (count($display_plots) == ($num_cols*$num_rows) || $i == ($num_obs-1)) {
			
			if (!file_exists(WORKING_DIR."/$output_filename")) {

				if (generateProfiles(PROFILE_PLOT, $display_plots, $output_filename, $num_cols, $num_rows)) {

					// Generate some cal profiles if requested
					if ($display_cals) {
						
						//echo "Displaying cals<br>\n";
						
						// set display_cals to false as argument to prune..
						// don't traverse another level afterwards
						
						// set the selected_archives_indices index the first to the last cals
						$cal_indices = array();
						for ($j = 0; $j < count($obs_cals[$selected_archives_indices[$i]]); $j++) {
							array_push($cal_indices, $j);
						}
						displayCalProfiles($obs_cals[$selected_archives_indices[$i]], $cal_indices, false);
					}

					//echo "Successfully generated $output_filename<br>\n";
				}
				else {
					//echo "Generate failed<br>\n";
				}
			}
			
			//echo "Moving: " . "mv ".WORKING_DIR."/*.".IMAGE_EXT. " " . PROFILE_DIR . "<br>\n";
			
			// Move all the generated image files into the pulse profile directory
			//exec("mv ".WORKING_DIR."/*.".IMAGE_EXT. " " . PROFILE_DIR, $output_array);
			
			//print_r($output_array);
			
			$display_plots = array();
						echo "<img src=\"".WEB_PROFILE_DIR."/$output_filename\"></img>\n";
						//echo "<img src=\"".PLOT_DIR."/$output_filename\"></img>\n";
		}
		
		echo "<br /><br />\n<hr />\n<br /><br />\n";

	}
}

function displayCalProfiles($all_archives, $selected_archives_indices) {

	$num_cols = NUM_PROFILE_COLUMNS;
	
	$num_rows = NUM_PROFILE_ROWS;
	
	$obs_cals;
	
	$archives_to_plot = count($selected_archives_indices);
		
	// If there are fewer profiles to plot than columns, 
	// plot these profiles on a full plot
	if ( count($archives_to_plot) < $num_cols) {
		$num_cols = $num_obs;
		$num_rows = 1;
	}
		
	$obs_cals = $_SESSION['obs_cals'];
	//echo "obs_cals = <pre>";
	//print_r($obs_cals);
	//echo "</pre>";
	$num_cols = 1;
	$num_rows = 1;
	
	// An array of profiles to display in a pgplot instance
	$display_plots = array();
	
	echo "<table border=\"0\"><tr>\n";
	
	for ($i = 0; $i < count($selected_archives_indices); $i++) {
		echo "<td>\n";
		
		//echo "index = $selected_archives_indices[$i]<br>\n";
		
		// Need to append the suffix so the location points to the scrunched data
		$profile_dir = rtrim($all_archives[$selected_archives_indices[$i]][DATA_LOCATION], "/") . SCRUNCHED_DIR_EXT;
		
		//echo "location at " . $profile_dir . "<br>\n";
		
		//array_push($profile_locations, $profile_location);
		
		$file = $all_archives[$selected_archives_indices[$i]][FILENAME];
		
		list($file_no_extension, $extension) =  split("\.", $file);
		
		//echo "File prefix = $file_no_extension, suffix = $extension<br>\n";
		
		
		$dirs = split("/", $profile_dir);

		$pulsar_name = $dirs[count($dirs)-1];
		
		// Need to create a symlink first because may not have write
		// access to the data directory. Don't want to mess up the data dir anyway
		if (!file_exists(WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT)) {
		
			//echo WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT." doesn't exist<br>\n";
			
			if (file_exists("$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT)) {
			
				echo "$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT." exists<br>\n";
				
				// Create a symlink in the working directory (which will be cleaned up regularly using a cron job)
				if (symlink ("$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT, WORKING_DIR."/$pulsar_name.$file_no_extension.".SCRUNCHED_FILE_EXT)) {
				
					//echo "Successfully created symlink: $profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT. " => " . WORKING_DIR."/$pulsar_name.$file_no_extension.".SCRUNCHED_FILE_EXT."<br>\n";
				}
				else {
					//echo "Failed to create symlink<br>\n";
				}
			}
			else {
				//echo "$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT." does NOT exist<br>\n";
			}
		}
		else {
			//echo WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT." exists<br>\n";
		}
		
		array_push($display_plots, "$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT);
		
		//print_r($display_plots);
		
		$output_filename = "$pulsar_name/$file_no_extension.".IMAGE_EXT;//date("YmdHis") . "." . IMAGE_EXT;
		
		//echo count($display_plots) . " " . $num_cols*$num_rows . ", i = " . $i . " ==? " . (count($archives_to_plot)-1) . "<br>\n";
		
		if (count($display_plots) == ($num_cols*$num_rows) || $i == ($num_obs-1)) {
			
			if (!file_exists(WORKING_DIR."/$output_filename")) {

				if (generateProfiles(PROFILE_PLOT, $display_plots, $output_filename, $num_cols, $num_rows)) {

					//echo "Successfully generated $output_filename<br>\n";
				}
				else {
					//echo "Generate failed<br>\n";
				}
			}
			
			//echo "Moving: " . "mv ".WORKING_DIR."/*.".IMAGE_EXT. " " . PROFILE_DIR . "<br>\n";
			
			// Move all the generated image files into the pulse profile directory
			//exec("mv ".WORKING_DIR."/*.".IMAGE_EXT. " " . PROFILE_DIR, $output_array);
			
			//print_r($output_array);
			
			$display_plots = array();
			echo "<img src=\"".WEB_PROFILE_DIR."/$output_filename\"></img>\n";
		}
		echo "</td>\n";
	}
	echo "</tr></table>\n";
}


// Function definitions
function generateProfiles($plot_type, $archives, $output_filename, $num_cols, $num_rows) {
	global $PLOT_COMMANDS;
	
	chdir(WORKING_DIR);

	if(file_exists("/pulsar/psr/linux/bin/pav")){
	  echo "PAV EXISTS!!<BR>\n";
	}
	else{
	  echo "PAV DOESN'T EXIST!!<br>\n";
	}

	$archive_list_str = "";
		
	foreach ($archives as $archive) {
		
		if (file_exists(WORKING_DIR."/$archive")) {
			echo "archive = ".WORKING_DIR."/$archive<br>output_filename = ".WORKING_DIR."/$output_filename<br>\n";
			//			$archive_list_str .= DATA_ARCH_DIR."/".WEB_DOWNLOADS_DIR."/"."$archive ";
			$archive_list_str .= WORKING_DIR."/"."$archive ";
			continue;
		}
		else {
			echo "generateProfile($plot_type, $archive, $output_filename): ".WORKING_DIR."/$archive does NOT exist!<br>\n";
			continue;
		}
	}
	// Use pav to generate the profile image
	if (file_exists(PSRCHIVE_DIR."/pav")) {
		$command = $PLOT_COMMANDS[$plot_type];
		$command .= "/$output_filename/png -N $num_cols,$num_rows $archive_list_str";

		echo "generateProfile: command = $command<br>\n";
		
		exec("pwd", $output_array);
		
		echo "current directory = " . $output_array[0] . "<br>\n";
		
		exec($command, $output_array);

		echo "$command<br>\n";
		echo "Output from this is:<br>";
		print_r($output_array);
		echo "<br>\n";
	}
	else {
		echo PSRCHIVE_DIR."/pav doesn't exist<br>\n";
	}


	// If this was successful and the image file exists, 
	// move it to an appropriate name and location that can be
	// accessed by the web server
	if (file_exists(PROFILE_DIR."/$output_filename")) {
		return true;
	}
	else {
		//echo PROFILE_DIR."/$output_filename doesn't exist<br>\n";
		//echo "generateProfile: ".WORKING_DIR."/$output_filename does NOt exist<br>\n";
	}
		
	
	return false;
}

function convert($ps_file, $output_file) {
	
	if (file_exists($ps_file)) {
	
		// Need to convert it to a gif file
		$command = CONVERT." $ps_file $output_file 2>&1";
		//echo "convert = $command<br>\n";
		exec($command, $output_array);
	}
	else {
		//echo "File $ps_file doesn't exist<br>\n";
	}
	
}

?>


</html>

